﻿using Infragistics.Win.UltraWinDock;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WD_RemoveContextMenuItem
{
    public partial class Form1 : Form
    {
        private bool subscribedToMenuPopup = false;
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraDockManager1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is PaneCaptionUIElement)
            {
                e.Element.Control.MouseDown += OnMouseDown;
            }
        }

        private void ultraDockManager1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is PaneCaptionUIElement)
            {
                e.Element.Control.MouseDown -= OnMouseDown;
            }
        }

        private void OnMouseDown(object sender, MouseEventArgs e)
        {
            if (subscribedToMenuPopup == false)
            {
                var contextMenu = ((Control)sender).ContextMenu;
                contextMenu.Popup += ContextMenu_Popup;
                subscribedToMenuPopup = true;
            }
        }

        private void ContextMenu_Popup(object sender, EventArgs e)
        {
            var igContextMenu = (Infragistics.Win.IGControls.IGContextMenu)sender;
            var hideItem = igContextMenu.MenuItems.OfType<MenuItem>().FirstOrDefault(i => i.Text.Contains("Hide"));
            if(hideItem != null )
                igContextMenu.MenuItems.Remove(hideItem);
        }
    }
}
